/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package com.axiros.axmobility.desktop;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Locale;

import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.AnnotationConfigApplicationContext;

import com.axiros.axmobility.AxSettings;
import com.axiros.axmobility.AxEvents;
import com.axiros.axmobility.AxMobility;
import com.axiros.axmobility.events.CycleEvents;
import com.axiros.axmobility.events.TR143Events;
import com.axiros.axmobility.events.TR143DetailEvents;
import com.axiros.axmobility.type.OnFinishedStatus;

import com.axiros.axmobility.tr143.TR143Diagnostic;
import com.axiros.axmobility.tr143.UDPDiagnostic;
import com.axiros.axmobility.tr143.TCPDiagnostic;
import com.axiros.axmobility.tr143.DownloadDiagnostic;
import com.axiros.axmobility.tr143.UploadDiagnostic;
import com.axiros.axmobility.tr143.UDPDiagnosticInProgress;
import com.axiros.axmobility.tr143.TCPDiagnosticInProgress;
import com.axiros.axmobility.tr143.DownloadDiagnosticInProgress;
import com.axiros.axmobility.tr143.UploadDiagnosticInProgress;
import com.axiros.axmobility.tr143.InProgress;
import com.axiros.axmobility.tr143.Details;

public class Launcher {
    public static void main(String[] args) {
        ApplicationContext context = new AnnotationConfigApplicationContext(SpringContext.class);
        MainFrame mainFrame = (MainFrame)context.getBean("mainFrame");
        AxMobility axd = Launcher.axmobilityStart(context, mainFrame, args);

        mainFrame.setArgs(args);
        mainFrame.init(axd);
        mainFrame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent evt) {
                try {
                    axd.shutdown();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }

    private static AxMobility axmobilityStart(ApplicationContext context, MainFrame frame, String[] args) {
        try {
            AxEvents events = new AxEvents.Builder()
                                          .withCycleEvents(new CycleEvents() {
                                              @Override
                                              public void onCanceled() {
                                                  System.out.println("Cycle event canceled");
                                                  frame.enableRun();
                                              }

                                              @Override
                                              public void onStarted() {
                                                  System.out.println("Cycle event onStarted");
                                                  frame.disableRun();
                                              }

                                              @Override
                                              public void onFinished(OnFinishedStatus status) {
                                                  System.out.println("Cycle event onFinished:" + status);
                                                  frame.enableRun();
                                                  frame.setDiagnostic("");
                                                  frame.gaugeSetUnit("");
                                                  frame.gaugeSetLimit(100);
                                                  frame.gaugeUpdate(0);
                                              }
                                          })
                                          .withTR143Events(new TR143Events() {
                                              @Override
                                              public void onBegin(TR143Diagnostic diagnostics) {
                                                  String unit = "";
                                                  String name = "";
                                                  double maxValue = 100;

                                                  if (diagnostics instanceof UDPDiagnostic) {
                                                      /* handle the UDP diagnostics */
                                                      unit = "ms";
                                                      name = "UDP";
                                                      maxValue = 100;
                                                  } else if (diagnostics instanceof TCPDiagnostic) {
                                                      /* handle the TCP diagnostics */
                                                      unit = "ms";
                                                      name = "TCP";
                                                      maxValue = 500;
                                                  } else if (diagnostics instanceof DownloadDiagnostic) {
                                                      /* handle the Download diagnostics */
                                                      unit = "mbps";
                                                      name = "Download";
                                                      maxValue = 300;
                                                  } else if (diagnostics instanceof UploadDiagnostic) {
                                                      /* handle the Upload diagnostics */
                                                      unit = "mbps";
                                                      name = "Upload";
                                                      maxValue = 100;
                                                  }

                                                  frame.setDiagnostic(name);
                                                  frame.gaugeSetUnit(unit);
                                                  frame.gaugeSetLimit(maxValue);
                                              }

                                              @Override
                                              public void onCompleted(TR143Diagnostic diagnostics) {
                                                  if (diagnostics instanceof UDPDiagnostic) {
                                                      /* handle the UDP diagnostics */
                                                  } else if (diagnostics instanceof TCPDiagnostic) {
                                                      /* handle the TCP diagnostics */
                                                  } else if (diagnostics instanceof DownloadDiagnostic) {
                                                      /* handle the Download diagnostics */
                                                  } else if (diagnostics instanceof UploadDiagnostic) {
                                                      /* handle the Upload diagnostics */
                                                  }
                                              }
                                          })
                                          .withTR143DetailEvents(new TR143DetailEvents() {
                                              @Override
                                              public void inProgress(TR143Diagnostic diagnostics, InProgress inProgress) {
                                                  double value = 0;

                                                  if (diagnostics instanceof UDPDiagnostic) {
                                                      /* handle the UDP diagnostics */
                                                      UDPDiagnosticInProgress udp = (UDPDiagnosticInProgress)inProgress;
                                                      value = udp.getAverageResponseTime() / 1000;
                                                  } else if (diagnostics instanceof TCPDiagnostic) {
                                                      /* handle the TCP diagnostics */
                                                      TCPDiagnosticInProgress tcp = (TCPDiagnosticInProgress)inProgress;
                                                      value = tcp.getAverageResponseTime() / 1000;
                                                  } else if (diagnostics instanceof DownloadDiagnostic) {
                                                      /* handle the Download diagnostics */
                                                      DownloadDiagnosticInProgress dl = (DownloadDiagnosticInProgress)inProgress;
                                                      value = dl.getAverageSpeed();
                                                  } else if (diagnostics instanceof UploadDiagnostic) {
                                                      /* handle the Upload diagnostics */
                                                      UploadDiagnosticInProgress up = (UploadDiagnosticInProgress)inProgress;
                                                      value = up.getAverageSpeed();
                                                  }

                                                  System.out.println(value);
                                                  frame.gaugeUpdate(value);
                                              }

                                              @Override
                                              public void details(TR143Diagnostic diagnostics, Details details) {
                                                  if (diagnostics instanceof UDPDiagnostic) {
                                                      /* handle the UDP diagnostics */
                                                  } else if (diagnostics instanceof TCPDiagnostic) {
                                                      /* handle the TCP diagnostics */
                                                  } else if (diagnostics instanceof DownloadDiagnostic) {
                                                      /* handle the Download diagnostics */
                                                  } else if (diagnostics instanceof UploadDiagnostic) {
                                                      /* handle the Upload diagnostics */
                                                  }
                                              }
                                          })
                                          .build();

            String key = args.length > 0 ? args[0] : context.getEnvironment().getProperty("acs_key");
            String path = System.getProperty("user.dir");
            String depPath = isWindows() ? path : context.getEnvironment().getProperty("dep_path");
            AxSettings settings = AxSettings.Builder()
                                            .withEvents(events)
                                            .withKey(key)
                                            .atDependencyPath(depPath)
                                            .atRootPath(path)
                                            .noPeriodic()
                                            .build();

            AxMobility axd = new AxMobility(settings);
            axd.start();

            return axd;
        } catch (Exception e) {
            e.printStackTrace();
        }

        return null;
    }

    private static boolean isWindows() {
        String OS = System.getProperty("os.name").toLowerCase(Locale.ROOT);
        return OS.contains("win");
    }
}
